// simple.frag

#extension GL_EXT_gpu_shader4 : enable

uniform sampler2D textureImage;
uniform int extremeAlpha;
uniform int convert;
uniform int backgroundTile;

void main (void)
{
    vec4 texColor = texture2D(textureImage, gl_TexCoord[0].st);

    texColor[0] += 0.0001;
    texColor[1] += 0.0001;
    texColor[2] += 0.0001;

    if (convert == 1){
	gl_FragColor[0] = texColor[3];
	gl_FragColor[1] = texColor[3];
	gl_FragColor[2] = texColor[3];
	gl_FragColor[3] = 1;
	return;
    }

    gl_FragColor[0] = texColor[0];
    gl_FragColor[1] = texColor[1];
    gl_FragColor[2] = texColor[2];
    float alpha = texColor[3];
    
    if (alpha > 1){
	if (extremeAlpha == 1){
	    gl_FragColor[0] *= alpha;
	    gl_FragColor[1] *= alpha;
	    gl_FragColor[2] *= alpha;
	}
	alpha = 1;
    }

    if (backgroundTile == 1){
	vec3 backimg = vec3(0.4, 0.4, 0.4);
	int tile = (int(gl_FragCoord.x / 16) + int(gl_FragCoord.y/ 16)) % 2;
	if (tile == 1) backimg = vec3(0.6, 0.6, 0.6);
	
	gl_FragColor[0] = gl_FragColor[0] * alpha + backimg * (1.0 - alpha);
	gl_FragColor[1] = gl_FragColor[1] * alpha + backimg * (1.0 - alpha);
	gl_FragColor[2] = gl_FragColor[2] * alpha + backimg * (1.0 - alpha);
    }
    
    gl_FragColor[3] = 1;
    
    return;
}
